import { MyContext } from '../file'

function publish(
  data:
    | { event: "CommentsDeleteEvent", payload: Drury }
    | { event: "CommentCreateEvent", payload: CommentCreateEvent }
    | { event: "CommentEditEvent", payload: CommentEditEvent }
    | { event: "CommentFlagEvent", payload: CommentFlagEvent }
    | { event: "CommentReactionEvent", payload: CommentReactionEvent }
    | { event: "CommentReactionUndoEvent", payload: CommentReactionUndoEvent }
    | { event: "EntityFlagEvent", payload: EntityFlagEvent }
    | { event: "EntityReactionEvent", payload: EntityReactionEvent }
    | { event: "EntityReactionUndoEvent", payload: EntityReactionUndoEvent }
    | { event: "ReactionEntityDeleteEvent", payload: ReactionEntityDeleteEvent }
): Promise<void>;
function publish(): Promise<void>{
  return Promise.resolve();
}

export type Publish = typeof publish

function eventSampler(args: { event: "CommentsDeleteEvent", override?: Partial<Drury> }): Drury
function eventSampler(args: { event: "CommentCreateEvent", override?: Partial<CommentCreateEvent> }): CommentCreateEvent
function eventSampler(args: { event: "CommentEditEvent", override?: Partial<CommentEditEvent> }): CommentEditEvent
function eventSampler(args: { event: "CommentFlagEvent", override?: Partial<CommentFlagEvent> }): CommentFlagEvent
function eventSampler(args: { event: "CommentReactionEvent", override?: Partial<CommentReactionEvent> }): CommentReactionEvent
function eventSampler(args: { event: "CommentReactionUndoEvent", override?: Partial<CommentReactionUndoEvent> }): CommentReactionUndoEvent
function eventSampler(args: { event: "EntityFlagEvent", override?: Partial<EntityFlagEvent> }): EntityFlagEvent
function eventSampler(args: { event: "EntityReactionEvent", override?: Partial<EntityReactionEvent> }): EntityReactionEvent
function eventSampler(args: { event: "EntityReactionUndoEvent", override?: Partial<EntityReactionUndoEvent> }): EntityReactionUndoEvent
function eventSampler(args: { event: "ReactionEntityDeleteEvent", override?: Partial<ReactionEntityDeleteEvent> }): ReactionEntityDeleteEvent
;function eventSampler(): {}{
  return {};
}
export type EventSampler = typeof eventSampler


export interface EventHandlers {
  DeleteGroup: (msg: MyDeleteQuery["DeleteGroup"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  AnswerAccept: (msg: AnswerAcceptQuery["AnswerAccept"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  AnswerCreate: (msg: AnswerCreateQuery["AnswerCreate"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  AnswerEdit: (msg: AnswerEditQuery["AnswerEdit"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  QuestionCreate: (msg: QuestionCreateQuery["QuestionCreate"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  QuestionEdit: (msg: QuestionEditQuery["QuestionEdit"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  QuestionResolve: (msg: QuestionResolveQuery["QuestionResolve"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  CommentCreate: (msg: CommentCreateQuery["CommentCreate"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  CommentReaction: (msg: CommentReactionQuery["CommentReaction"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  EntityReaction: (msg: EntityReactionQuery["EntityReaction"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  AnswerAcceptUndo: (msg: AnswerAcceptUndoQuery["AnswerAcceptUndo"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  QuestionResolveUndo: (msg: QuestionResolveUndoQuery["QuestionResolveUndo"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  AnswerDelete: (msg: AnswerDeleteQuery["AnswerDelete"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  QuestionDelete: (msg: QuestionDeleteQuery["QuestionDelete"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  CommentReactionUndo: (msg: CommentReactionUndoQuery["CommentReactionUndo"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  EntityReactionUndo: (msg: EntityReactionUndoQuery["EntityReactionUndo"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  CommentsDelete: (msg: CommentsDeleteQuery["CommentsDelete"], ctx: MyContext, fullPayload: {}) => Promise<any>,
  ReactionEntityDelete: (msg: ReactionEntityDeleteQuery["ReactionEntityDelete"], ctx: MyContext, fullPayload: {}) => Promise<any>
}
export enum Events {
  DeleteGroup = "DeleteGroup",
  AnswerAccept = "AnswerAccept",
  AnswerCreate = "AnswerCreate",
  AnswerEdit = "AnswerEdit",
  QuestionCreate = "QuestionCreate",
  QuestionEdit = "QuestionEdit",
  QuestionResolve = "QuestionResolve",
  CommentCreate = "CommentCreate",
  CommentReaction = "CommentReaction",
  EntityReaction = "EntityReaction",
  AnswerAcceptUndo = "AnswerAcceptUndo",
  QuestionResolveUndo = "QuestionResolveUndo",
  AnswerDelete = "AnswerDelete",
  QuestionDelete = "QuestionDelete",
  CommentReactionUndo = "CommentReactionUndo",
  EntityReactionUndo = "EntityReactionUndo",
  CommentsDelete = "CommentsDelete",
  ReactionEntityDelete = "ReactionEntityDelete",
}